// Sorry for the very cryptic file. It is cryptic not because I want it to be
// cryptic, but because it must be written in such manner. I have very strong
// reasons for usage of (very awkward) casting arrays to functions. Namely,
// such definitions allow that a function which is not called in the program
// will not be included in the program, and a function which is called more
// than once will be included just once. The first property would not be true
// if a function is implemented as a "normal" function in the header file, and
// the second property would not be true if a function is implemented as a
// smart inline macro. In "normal" C compilers, such problems are solved using
// an external library of object files which contain implementations of all
// functions, and they would be linked with the program when necessary. But
// note that TI-GCC linker does not support external libraries of object files,
// so for a while, such "cryptic" definitions are the only solution! "True
// sources" of all routines will be presented in a file named "source".

#ifndef __STDIO
#define __STDIO

#ifndef NOSTUB
#ifndef DOORS
#error: Neither "nostub.h" nor "doors.h" is included!
#endif
#endif

#undef NULL
#undef size_t
#define NULL ((void*)0)
#define size_t unsigned long

#ifndef __VA_LIST
#define __VA_LIST

typedef void *va_list;

#endif

#ifndef __SPRINTF
#define __SPRINTF

#define sprintf _rom_call(int,(char*,char*,...),53)
#define strerror _rom_call(char*,(int),27D)

#ifdef DOORS

int sprintf(char*,char*,...);
char *strerror(int);

#endif

#endif

#define printf_xy(x,y,f...) \
  ({char __s[200]; _rom_call(int,(char*,char*,...),53)(__s ,##f); \
  _rom_call(void,(int,int,char*,int),1A9)(x,y,__s,4);})

#define EOF (-1)

enum FileFlags {_F_READ=0x0001,_F_WRIT=0x0002,_F_RDWR=0x0003,_F_ERR=0x0010,
  _F_EOF=0x0020,_F_BIN=0x0040};

enum SeekModes {SEEK_SET,SEEK_CUR,SEEK_END};

typedef struct
  {
    char *fpos;
    void *base;
    unsigned int handle;
    int flags;
    int unget;
    int alloc;
  } FILE;

typedef unsigned long fpos_t;

#define vcbprintf ({register long __a=32+*(long*)(*(long*)0xC8+0x14C); \
  (void(*)(void(*)(char,void**),void**,char*,void*))(__a+*(int*)__a);})

#define vprintf(f,a) \
  vcbprintf((void(*)(char,void**))fputchar,NULL,(f),(a))
#define vfprintf(s,f,a) \
  vcbprintf((void(*)(char,void**))fputc,(void**)(s),(f),(a))
#define vsprintf(b,f,a) ((void)({void *__p=(b); \
  vcbprintf((void(*)(char,void**))strputchar,&__p,(f),(a)); *(char*)__p=0;}))

#define fputchar ((int(*)(char))(int[]){0x4E56,-20,0x48E7,0x1F3C,0x4240, \
  0x1C2E,9,0x2A78,0xC8,0x206D,0x638,0x4E90,0x3800,0xE34C,0x5C44,0x266D,0xBC, \
  0x486E,-18,0x206D,0x680,0x4E90,0x3A2E,-8,0x362E,-6,0x3F06,0x206D,0x640, \
  0x4E90,0x3E00,0xC06,10,0x670E,0x3005,0xD047,0x4241,0x122B,2,0xB240,0x6C04, \
  0x4245,0xD644,0x3003,0xD044,0x4241,0x122B,3,0xB240,0x6C10,0x4257,0x3F04, \
  0x2F0B,0x2F0B,0x206D,0x62C,0x4E90,0x9644,0x3EBC,4,0x3F06,0x3F03,0x3F05, \
  0xC06,10,0x6708,0x206D,0x690,0x4E90,0xDF57,0x206D,0x674,0x4E90,0x3006, \
  0x4CEE,0x3CF8,-56,0x4E5E,0x4E75})

#define strputchar ((void(*)(char,void**))(int[]){0x226F,6,0x2051,0x10AF,5, \
  0x5291,0x4E75})

#define puts(s) (((void(*)(void*,char*))((int[]){0x2F48,8,0x3F00,0x206F,6, \
  0x4E90,0x548F,0x206F,8,0x1018,0x66EA,0x4E75}+7))(fputchar,s))

#define printf(f...) (((void(*)(void*,char*,...))(int[]){0x2078,0xC8,0x2068, \
  0x14C,0x41E8,32,0x3250,0x486F,12,0x2F2F,12,0x42A7,0x2F2F,16,0x4EB1,0x8800, \
  0x4FEF,16,0x4E75})(fputchar ,##f))

#define fprintf(s,f...) (((void(*)(void*,FILE*,char*,...))(long[]) \
  {0x207800C8,0x2068014C,0x41E80020,0x3250486F,0x102F2F,0x102F2F,0x102F2F, \
  0x104EB1,0x88004FEF,0x104E75})(fputc,s ,##f))

#define clrscr ((void(*)(void))(long[]){0x207800C8,0x20680674,0x42A74E90, \
  0x588F2078,0xC82068,0x6784ED0})

#define fopen ((FILE*(*)(char*,char*))(int[]){0x4E56,0xFFCC,0x48E7,0x1E3C, \
  0x246E,8,0x2C2E,12,0x49EE,0xFFCE,0x2246,0x1811,0x4245,0xC29,0x62,1,0x6708, \
  0xC29,0x62,2,0x6602,0x7A01,0x2078,0xC8,0x4878,16,0x2068,0x288,0x4E90, \
  0x2A48,0x588F,0xBAFC,0,0x6700,0x96,0x421C,0x6002,0x528C,0x101A,0x1880, \
  0x66F8,0xC04,0x72,0x6706,0xC04,0x61,0x6642,0x7601,0x2478,0xC8,0x2F0C, \
  0x206A,0x180,0x4E90,0x2F00,0x206A,0x1E4,0x4E90,0x2448,0x508F,0xB4FC,0, \
  0x660A,0xC04,0x72,0x6756,0x7877,0x6018,0x2078,0xC8,0x302A,12,0x3B40,8, \
  0x3F00,0x2068,0x264,0x4E90,0x2648,0x548F,0xC04,0x77,0x665E,0x7602,0x367C, \
  0xC8,0x2453,0x2F0C,0x206A,0x170,0x4E90,0x2F00,0x206A,0x1E4,0x4E90,0x2448, \
  0x2053,0x4878,0x403,0x2068,0x240,0x4E90,0x3540,12,0x3B40,8,0x4FEF,12, \
  0x6606,0x91C8,0x6000,0x86,0x2078,0xC8,0x3F00,0x2068,0x264,0x4E90,0x2648, \
  0x4A45,0x6704,0x4253,0x600E,0x26BC,5,1,0x277C,0x2000,0xE000,4,0x4280, \
  0x3013,0xD08B,0x4A45,0x6702,0x5480,0xC04,0x61,0x6606,0x7602,0x2200,0x600C, \
  0x220B,0x5A81,0x4A45,0x6704,0x220B,0x5481,0xB280,0x6604,0x43,32,0x2246, \
  0xC29,0x2B,1,0x6708,0xC29,0x2B,2,0x6604,0x43,3,0x4A45,0x6704,0x43,0x40, \
  0x3B43,10,0x2B4B,4,0x2A81,0x426D,12,0x3B7C,0x403,14,0x204D,0x4CEE,0x3C78, \
  0xFFAC,0x4E5E,0x4E75})

#define fclose ((int(*)(FILE*))(int[]){0x4E56,0,0x48E7,0x1030,0x266E,8, \
  0xB6FC,0,0x6604,0x70FF,0x6026,0x82B,4,11,0x56C3,0x4883,0x347C,0xC8,0x2052, \
  0x3F2B,8,0x2068,0x27C,0x4E90,0x2052,0x2F0B,0x2068,0x28C,0x4E90,0x3003, \
  0x4CEE,0xC08,0xFFF4,0x4E5E,0x4E75})

#define ftell ((long(*)(FILE*))(int[]){0x4E56,0,0x206E,8,0x3428,10,0x802,4, \
  0x6704,0x70FF,0x6014,0x2210,0x92A8,4,0x2001,0x5B80,0x802,6,0x6704,0x2001, \
  0x5580,0x4E5E,0x4E75})

#define fseek ((long(*)(FILE*,long,int))(long[]){0x4E560000,0x48E71E20, \
  0x246E0008,0x282E000C,0x3A2E0010,0x362A000A,0x3C033203,0x2410040, \
  0x206A0004,0x43E80005,0x670443E8,0x24280,0x30102408,0xD4804A41,0x67025482, \
  0x4A45670C,0x20020C45,0x16606,0x20126002,0x2009D084,0x8060004,0x670470FF, \
  0x6032B3C0,0x620AB480,0x65060C45,0x2630C,0x460010,0x3546000A,0x70FF6018, \
  0x2480422A,0xCB480,0x66060043,0x206004,0x243FFDF,0x3543000A,0x4CDF0478, \
  0x4E5E4E75})

#define fputc ((int(*)(int,FILE*))(int[]){0x4E56,0,0x48E7,0x1C30,0x382E,8, \
  0x266E,10,0x322B,10,0x3601,0xEC4B,0xA43,1,0x243,1,0x246B,4,0x2A0A,0x801,4, \
  0x6706,0x70FF,0x6000,0xDC,0x0801,1,0x660E,0x41,0x10,0x3741,10,0x70FF, \
  0x6000,0xC8,0x3012,0x640,10,0xB06B,14,0x635C,0x347C,0xC8,0x2052,0x3F2B,8, \
  0x2068,0x27C,0x4E90,0x2052,0x302B,14,0x640,0x422,0x3740,14,0x3240,0x2F09, \
  0x3F2B,8,0x2068,0x274,0x4E90,0x508F,0x4A40,0x660A,0x6B,16,10,0x70FF, \
  0x607E,0x2078,0xC8,0x3F2B,8,0x2068,0x264,0x4E90,0x2748,4,0x2448,0x200A, \
  0x9085,0xD193,0x548F,0x322B,10,0x801,5,0x6702,0x5252,0xC44,10,0x6606, \
  0x4A43,0x6702,0x780D,0x2053,0x1084,0x5293,0xC44,13,0x660E,0x4A43,0x670A, \
  0x2F0B,0x3F3C,32,0x4EBA,0xFF26,0x4280,0x3012,0xD08A,0x2213,0x4A43,0x6608, \
  0x5480,0xB280,0x6706,0x601A,0xB280,0x6616,0x6B,32,10,0x4A43,0x670C,0x2053, \
  0x4210,0x2053,0x117C,0xFFE0,1,0x3004,0x4CEE,0xC38,0xFFEC,0x4E5E,0x4E75})

#define fgetc ((int(*)(FILE*))(long[]){0x4E560000,0x48E71820,0x246E0008, \
  0x302A000A,0x3600EC4B,0x0A430001,0x2430001,0x8000004,0x660E0800,0x660C, \
  0x400010,0x3540000A,0x70FF6052,0x382A000C,0x6C0A426A,0xC4240,0x10046042, \
  0x8000005,0x66E62052,0x42441810,0x52920C44,0xD660A,0x4A436706,0x2F0A4EBA, \
  0xFFA0206A,0x44280,0x3010D088,0x22124A43,0x66085480,0xB2806706,0x600AB280, \
  0x6606006A,0x20000A,0x30044CEE,0x418FFF4,0x4E5E4E75})

#define fputs(s,f) (((int(*)(void*,char*,FILE*))((int[]){0x2F48,8,0x2F2F,12, \
  0x3F01,0x206F,10,0x4E90,0x5C8F,0x206F,8,0x4241,0x1218,0x66E4,0x4E75}+9)) \
  (fputc,s,f))

#define fgets(s,n,f) (((char*(*)(void*,char*,int,FILE*))(long[]){0x4E560000, \
  0x48E71838,0x286E0008,0x282E000C,0x266E0012,0x2444362E,0x106024, \
  0x2F0B4E94,0x588F0C40,0xFFFF671E,0xC40000D,0x660A082B,0x6000B,0x6602700A, \
  0x14C00C00,0xA6706,0x53434A43,0x6ED64212,0xC40FFFF,0x6604B88A,0x67042004, \
  0x60027000,0x20404CEE,0x1C18FFEC,0x4E5E4E75})(fgetc,s,n,f))

#define fwrite(p,s,n,f) (((unsigned(*)(int(*)(int,FILE*),void*,int,int, \
  FILE*))(int[]){0x4E56,0,0x48E7,0x1F38,0x286E,8,0x246E,12,0x3A2E,16,0x3C2E, \
  18,0x266E,20,0x3E2B,10,0x3207,0x41,0x40,0x3741,10,0x4244,0xBC44,0x6322, \
  0x4243,0xBA43,0x6316,0x2F0B,0x121A,0x4881,0x3F01,0x4E94,0x5C8F,0x4A40, \
  0x6D0C,0x5243,0xBA43,0x62EA,0x5244,0xBC44,0x62DE,0x3747,10,0x3004,0x4CEE, \
  0x1CF8,0xFFE0,0x4E5E,0x4E75})(fputc,p,s,n,f))

#define fread(p,s,n,f) (((unsigned(*)(int(*)(FILE*),void*,int,int,FILE*)) \
  (long[]){0x4E560000,0x48E71F38,0x286E0008,0x246E000C,0x3A2E0010, \
  0x3C2E0012,0x266E0014,0x3E2B000A,0x32070041,0x403741,0xA4244,0xBC44631C, \
  0x4243BA43,0x63102F0B,0x4E9414C0,0x588F6D0C,0x5243BA43,0x62F05244, \
  0xBC4462E4,0x3747000A,0x30044CEE,0x1CF8FFE0,0x4E5E4E75})(fgetc,p,s,n,f))

#define rename ((int(*)(char*,char*))(long[]){0x4E56FF9C,0x2F0B2F0A, \
  0x206E0008,0x266E000C,0x422EFF9C,0x45EEFF9D,0x6002528A,0x10181480, \
  0x66F843EA,0x16002,0x5289101B,0x128066F8,0x207800C8,0x2F092F0A,0x2068018C, \
  0x4E905340,0x246EFF94,0x266EFF98,0x4E5E4E75})

#define unlink ((int(*)(char*))(long[]){0x4E56FFCC,0x206E0008,0x422EFFCE, \
  0x43EEFFCF,0x60025289,0x10181280,0x66F82078,0xC82F09,0x20680178, \
  0x4E905340,0x4E5E4E75})

#define fgetchar() ({register int __c=_rom_call(int,(),51)(); \
  fputchar((__c=='\r')?'\n':__c);})

#define gets(s) ({register int __c; register char *__p=s; \
  while((*__p++=fputchar(((__c=_rom_call(int,(),51)())=='\r')?'\n':__c)) \
  !='\n'); __p[-1]=0; s; })

#define getchar() fgetchar()
#define putchar(c) fputchar(c)
#define getc(f) fgetc(f)
#define putc(c,f) fputc((c),(f))

#define feof(f) (((f)->flags)&_F_EOF)
#define ferror(f) (((f)->flags)&_F_ERR)
#define clearerr(f) ((void)(((f)->flags)&=~(_F_EOF|_F_ERR)))

#define freopen(n,m,f) (fclose(f),(f)=fopen((n),(m)))

#define fgetpos(f,p) ((*(p)=ftell(f))==EOF)
#define fsetpos(f,p) fseek((f),*(p),SEEK_SET)

#define rewind(f) ((void)(fseek((f),0,SEEK_SET),(f)->flags&=~_F_ERR))

#define ungetc(c,f) ((f)->unget=((c)|0x8000))
#define fflush(f) ((f)->unget=0)

#define remove(f) unlink(f)

#endif
